import os
import appuifw
import e32
import sys
import time
logotype=1
class Directory_iter:
    def __init__(self, drive_list):
        self.drives = [((i, "盘".decode("utf-8"))) for i in drive_list]
        self.at_root = 1
        self.path = '\\'
    def pop(self):
        if os.path.splitdrive(self.path)[1] == '\\':
            self.path = '\\'
            self.at_root = 1
        else:
            self.path = os.path.split(self.path)[0]
    def add(self, i):
        if self.at_root:
            self.path = str(self.drives[i][0]+u'\\')
            self.at_root = 0
        else:
            self.path = os.path.join(self.path, os.listdir(self.name())[i])
    def name(self):
        return self.path
    def list_repr(self):
        if self.at_root:
            return self.drives
        else:
            def item_format(i):
                full_name = os.path.join(str(self.name()), i)
                try:
                    time_field = time.strftime("%Y.%m.%d %H:%M",\
                                               time.localtime(os.stat(full_name).st_mtime));
                    info_field = time_field+"  "+str(os.stat(full_name).st_size)+"B"
                    if os.path.isdir(full_name):
                        name_field = "["+i+"]"
                    else:
                        name_field = i
                except:
                    info_field = "[inaccessible]"
                    name_field = "["+i+"]"
                return (unicode(name_field), unicode(info_field))
            try:
                l = map(item_format, os.listdir(self.name()))
            except:
                l = []
            return l
    def entry(self, i):
        return os.path.join(self.name(), os.listdir(self.name())[i])
class Filebrowser:
    def __init__(self):
        self.script_lock = e32.Ao_lock()
        self.dir_stack = []
        self.current_dir = Directory_iter(e32.drive_list())
    def run(self):
        from key_codes import EKeyLeftArrow
        entries = self.current_dir.list_repr()
        if not self.current_dir.at_root:
            entries.insert(0, ("返回上级目录".decode("utf-8"),u".."))
        self.lb = appuifw.Listbox(entries, self.lbox_observe)
        self.lb.bind(EKeyLeftArrow, lambda: self.lbox_observe(0))
        old_title = "选择图片".decode("utf-8")
        self.refresh()
        self.script_lock.wait()
        appuifw.app.title = old_title
        appuifw.app.body = None
        self.lb = None
    def refresh(self):    
        appuifw.app.title = "选择图片".decode("utf-8")    
        appuifw.app.menu = []
        appuifw.app.exit_key_handler = shagon_presents_main()
        appuifw.app.body = self.lb

    def do_exit(self):
        shagon_presents_main()

    def exit_key_handler(self):
        appuifw.app.exit_key_handler = shagon_presents_main()
 

    def lbox_observe(self, ind = None):
        if not ind == None:
            index = ind
        else:
            index = self.lb.current()
        focused_item = 0

        if self.current_dir.at_root:
            self.dir_stack.append(index)
            self.current_dir.add(index)
        elif index == 0:                            
            focused_item = self.dir_stack.pop()
            self.current_dir.pop()
        elif os.path.isdir(self.current_dir.entry(index-1)):
            self.dir_stack.append(index)
            self.current_dir.add(index-1)
        else:
            item = self.current_dir.entry(index-1)   
            if os.path.splitext(item)[1].lower()<>u'.bmp':
                appuifw.note("这不是BMP图片".decode("utf-8"),"error")
            else:
                i = appuifw.popup_menu(["查看图片".decode("utf-8"),"替换网标".decode("utf-8")])
                if i == 0:
                    try:
                        appuifw.Content_handler().open(item)
                    except:
                        appuifw.note("无法打开\n图片可能已经损坏".decode("utf-8"),"error") 
                elif i == 1:
                    filerootname="c:\\system\\apps\\phone\\oplogo\\"
                    if logotype==1:
                        filename=filerootname+"460_0_0.bmp"
                    else:
                        filename=filerootname+"460_0_1.bmp"
                    e32.file_copy(filename,item)
                    appuifw.note("替换网标成功\n重启之后生效".decode("utf-8"),"conf")
                    
                    return
                    shagon_presents_main()
                    
                
        entries = self.current_dir.list_repr()
        if not self.current_dir.at_root:
            entries.insert(0, ("返回上级目录".decode("utf-8"),u".."))
        self.lb.set_list(entries, focused_item)


def exit():
    appuifw.app.set_exit()
appuifw.app.exit_key_handler=exit


def cancel():
    shagon_presents_main()
    

def shagon_presents_main():
    appuifw.app.screen='normal'
    appuifw.app.title=' 酷网标'.decode("utf-8")
    appuifw.app.exit_key_handler=exit  
    canvas=appuifw.Canvas(event_callback=None, redraw_callback=None)
    appuifw.app.body=canvas   
    canvas.text((55,30),"杜俊作品".decode("utf-8"),0xff0232,'title')
    canvas.text((10,60),"—————————————".decode("utf-8"),0x0000ff,'dense')
    canvas.text((10,75),"自定义图片替换手机网络标志".decode("utf-8"),0x0000ff,'dense')
    canvas.text((10,93),"支持".decode("utf-8"),0x0000ff,'dense')
    canvas.text((35,93),"“移动”".decode("utf-8"),0xab1f7e,'dense')
    canvas.text((85,93),"和".decode("utf-8"),0x0000ff,'dense')
    canvas.text((100,93),"“联通”".decode("utf-8"),0xab1f7e,'dense')  
    canvas.text((10,105),"—————————————".decode("utf-8"),0x0000ff,'dense') 
    
    
    
    appuifw.app.menu =[
                       (
                         ('开始'.decode("utf-8")),
                         (
                          ('替换网标'.decode("utf-8"),coolstart),
                          ('还原网标'.decode("utf-8"),cooldelete)
                                                                )), 
    
                       ('帮助'.decode("utf-8"),help_info),
                       (
                         ('关于'.decode("utf-8")),
                         (
                          ('关于作者'.decode("utf-8"),about_info),
                          ('特别鸣谢'.decode("utf-8"),thank_info)
                                                                )),   
                      
                       ('退出'.decode("utf-8"),exit)]  
def about_info():
    appuifw.note('shagon作品\nwww.cnpda.com.cn\nCNPDA编程组\n2007.10.23'.decode("utf-8"), "info")
    shagon_presents_main()
    
def thank_info():
    appuifw.note('特别感谢\n“汉化浪子”\n建议及测试'.decode("utf-8"), "info")
    shagon_presents_main()

def help_info():
    appuifw.app.exit_key_handler=cancel
    appuifw.app.body =appuifw.Text('使用说明:\n      选择运营商，然后从文件夹中选择一张97×25象素的BMP图片，即可替换网络标志。\n      文件夹和文件名都不能含有中文，否则无法找到。如果遇到这种情况，请尝试将图片重命名，并移到根目录。'.decode("utf-8"))

def coolstart():
    global logotype    
    entry=["中国移动".decode("utf-8"),"中国联通".decode("utf-8")]
    index= appuifw.popup_menu(entry,"选择运营商".decode("utf-8"))
    if index==None: shagon_presents_main()    
    else:
        if index==0: logotype=1
        else: logotype=2      
        appuifw.note("选择一张BMP图片".decode("utf-8"),"info")
        Filebrowser().run()        
def _cooldelete(): 
    filerootname="c:\\system\\apps\\phone\\oplogo\\"
    filename=filerootname+"460_0_0.bmp"
    try:
        os.remove(filename)
    except:
        pass
    filename=filerootname+"460_0_1.bmp"
    try:
        os.remove(filename)
    except:
        pass
    appuifw.note("还原网标成功\n重启之后生效".decode("utf-8"),"conf")
    shagon_presents_main()
def cooldelete():
    if appuifw.query("确定要还原网标".decode("utf-8"),"query"): _cooldelete()
    else: cancel()
    

def coolrun():
    shagon_presents_main()    
    
app_lock=e32.Ao_lock()
coolrun()
app_lock.wait()